/*
	Copyright (c) 2004-2011, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/

//>>built
define("dojo/dnd/Manager",["../_base/array","../_base/connect","../_base/declare","../_base/event","../_base/window","../dom-class","../Evented","../keys","../topic","./common","./autoscroll","./Avatar"],function(_1,_2,_3,_4,_5,_6,_7,_8,_9,_a,_b,_c){
var _d=_3("dojo.dnd.Manager",[_7],{constructor:function(){
this.avatar=null;
this.source=null;
this.nodes=[];
this.copy=true;
this.target=null;
this.canDropFlag=false;
this.events=[];
},OFFSET_X:16,OFFSET_Y:16,overSource:function(_e){
if(this.avatar){
this.target=(_e&&_e.targetState!="Disabled")?_e:null;
this.canDropFlag=Boolean(this.target);
this.avatar.update();
}
_9.publish("/dnd/source/over",_e);
},outSource:function(_f){
if(this.avatar){
if(this.target==_f){
this.target=null;
this.canDropFlag=false;
this.avatar.update();
_9.publish("/dnd/source/over",null);
}
}else{
_9.publish("/dnd/source/over",null);
}
},startDrag:function(_10,_11,_12){
this.source=_10;
this.nodes=_11;
this.copy=Boolean(_12);
this.avatar=this.makeAvatar();
_5.body().appendChild(this.avatar.node);
_9.publish("/dnd/start",_10,_11,this.copy);
this.events=[_2.connect(_5.doc,"onmousemove",this,"onMouseMove"),_2.connect(_5.doc,"onmouseup",this,"onMouseUp"),_2.connect(_5.doc,"onkeydown",this,"onKeyDown"),_2.connect(_5.doc,"onkeyup",this,"onKeyUp"),_2.connect(_5.doc,"ondragstart",_4.stop),_2.connect(_5.body(),"onselectstart",_4.stop)];
var c="dojoDnd"+(_12?"Copy":"Move");
_6.add(_5.body(),c);
},canDrop:function(_13){
var _14=Boolean(this.target&&_13);
if(this.canDropFlag!=_14){
this.canDropFlag=_14;
this.avatar.update();
}
},stopDrag:function(){
_6.remove(_5.body(),["dojoDndCopy","dojoDndMove"]);
_1.forEach(this.events,_2.disconnect);
this.events=[];
this.avatar.destroy();
this.avatar=null;
this.source=this.target=null;
this.nodes=[];
},makeAvatar:function(){
return new _c(this);
},updateAvatar:function(){
this.avatar.update();
},onMouseMove:function(e){
var a=this.avatar;
if(a){
_b.autoScrollNodes(e);
var s=a.node.style;
s.left=(e.pageX+this.OFFSET_X)+"px";
s.top=(e.pageY+this.OFFSET_Y)+"px";
var _15=Boolean(this.source.copyState(_2.isCopyKey(e)));
if(this.copy!=_15){
this._setCopyStatus(_15);
}
}
},onMouseUp:function(e){
if(this.avatar){
if(this.target&&this.canDropFlag){
var _16=Boolean(this.source.copyState(dojo.isCopyKey(e)));
_9.publish("/dnd/drop/before",this.source,this.nodes,_16,this.target,e);
_9.publish("/dnd/drop",this.source,this.nodes,_16,this.target,e);
}else{
_9.publish("/dnd/cancel");
}
this.stopDrag();
}
},onKeyDown:function(e){
if(this.avatar){
switch(e.keyCode){
case _8.CTRL:
var _17=Boolean(this.source.copyState(true));
if(this.copy!=_17){
this._setCopyStatus(_17);
}
break;
case _8.ESCAPE:
_9.publish("/dnd/cancel");
this.stopDrag();
break;
}
}
},onKeyUp:function(e){
if(this.avatar&&e.keyCode==_8.CTRL){
var _18=Boolean(this.source.copyState(false));
if(this.copy!=_18){
this._setCopyStatus(_18);
}
}
},_setCopyStatus:function(_19){
this.copy=_19;
this.source._markDndStatus(this.copy);
this.updateAvatar();
_6.replace(_5.body(),"dojoDnd"+(this.copy?"Copy":"Move"),"dojoDnd"+(this.copy?"Move":"Copy"));
}});
_a._manager=null;
_d.manager=_a.manager=function(){
if(!_a._manager){
_a._manager=new _d();
}
return _a._manager;
};
return _d;
});
