//>>built
define("dojox/charting/plot2d/Grid",["dojo/_base/lang","dojo/_base/declare","dojo/_base/connect","dojo/_base/array","../Element","./common","dojox/lang/utils","dojox/gfx/fx"],function(_1,_2,_3,_4,_5,dc,du,fx){
return _2("dojox.charting.plot2d.Grid",_5,{defaultParams:{hAxis:"x",vAxis:"y",hMajorLines:true,hMinorLines:false,vMajorLines:true,vMinorLines:false,hStripes:false,vStripes:false,animate:null,enableCache:false,renderOnAxis:true},optionalParams:{majorHLine:{},minorHLine:{},majorVLine:{},minorVLine:{}},constructor:function(_6,_7){
this.opt=_1.clone(this.defaultParams);
du.updateWithObject(this.opt,_7);
du.updateWithPattern(this.opt,_7,this.optionalParams);
this.hAxis=this.opt.hAxis;
this.vAxis=this.opt.vAxis;
this.dirty=true;
this.animate=this.opt.animate;
this.zoom=null,this.zoomQueue=[];
this.lastWindow={vscale:1,hscale:1,xoffset:0,yoffset:0};
if(this.opt.enableCache){
this._lineFreePool=[];
this._lineUsePool=[];
}
},clear:function(){
this._hAxis=null;
this._vAxis=null;
this.dirty=true;
return this;
},setAxis:function(_8){
if(_8){
this[_8.vertical?"_vAxis":"_hAxis"]=_8;
}
return this;
},addSeries:function(_9){
return this;
},getSeriesStats:function(){
return _1.delegate(dc.defaultStats);
},initializeScalers:function(){
return this;
},isDirty:function(){
return this.dirty||this._hAxis&&this._hAxis.dirty||this._vAxis&&this._vAxis.dirty;
},performZoom:function(_a,_b){
var vs=this._vAxis.scale||1,hs=this._hAxis.scale||1,_c=_a.height-_b.b,_d=this._hAxis.getScaler().bounds,_e=(_d.from-_d.lower)*_d.scale,_f=this._vAxis.getScaler().bounds,_10=(_f.from-_f.lower)*_f.scale,_11=vs/this.lastWindow.vscale,_12=hs/this.lastWindow.hscale,_13=(this.lastWindow.xoffset-_e)/((this.lastWindow.hscale==1)?hs:this.lastWindow.hscale),_14=(_10-this.lastWindow.yoffset)/((this.lastWindow.vscale==1)?vs:this.lastWindow.vscale),_15=this.group,_16=fx.animateTransform(_1.delegate({shape:_15,duration:1200,transform:[{name:"translate",start:[0,0],end:[_b.l*(1-_12),_c*(1-_11)]},{name:"scale",start:[1,1],end:[_12,_11]},{name:"original"},{name:"translate",start:[0,0],end:[_13,_14]}]},this.zoom));
_1.mixin(this.lastWindow,{vscale:vs,hscale:hs,xoffset:_e,yoffset:_10});
this.zoomQueue.push(_16);
_3.connect(_16,"onEnd",this,function(){
this.zoom=null;
this.zoomQueue.shift();
if(this.zoomQueue.length>0){
this.zoomQueue[0].play();
}
});
if(this.zoomQueue.length==1){
this.zoomQueue[0].play();
}
return this;
},getRequiredColors:function(){
return 0;
},cleanGroup:function(){
this.inherited(arguments);
if(this.opt.enableCache){
this._lineFreePool=this._lineFreePool.concat(this._lineUsePool);
this._lineUsePool=[];
}
},createLine:function(_17,_18){
var _19;
if(this.opt.enableCache&&this._lineFreePool.length>0){
_19=this._lineFreePool.pop();
_19.setShape(_18);
_17.add(_19);
}else{
_19=_17.createLine(_18);
}
if(this.opt.enableCache){
this._lineUsePool.push(_19);
}
return _19;
},render:function(dim,_1a){
if(this.zoom){
return this.performZoom(dim,_1a);
}
this.dirty=this.isDirty();
if(!this.dirty){
return this;
}
this.cleanGroup();
var s=this.group,ta=this.chart.theme,_1b;
var _1c=this.opt.renderOnAxis;
if(this._vAxis){
var _1d=this._vAxis.getScaler();
if(_1d){
var vt=_1d.scaler.getTransformerFromModel(_1d);
var _1e;
_1e=this._vAxis.getTicks();
if(_1e!=null){
if(this.opt.hMinorLines){
_1b=this.opt.minorHLine||(ta.grid&&ta.grid.minorLine)||ta.axis.minorTick;
_4.forEach(_1e.minor,function(_1f){
if(!_1c&&_1f.value==(this._vAxis.opt.leftBottom?_1d.bounds.from:_1d.bounds.to)){
return;
}
var y=dim.height-_1a.b-vt(_1f.value);
var _20=this.createLine(s,{x1:_1a.l,y1:y,x2:dim.width-_1a.r,y2:y}).setStroke(_1b);
if(this.animate){
this._animateGrid(_20,"h",_1a.l,_1a.r+_1a.l-dim.width);
}
},this);
}
if(this.opt.hMajorLines){
_1b=this.opt.majorHLine||(ta.grid&&ta.grid.majorLine)||ta.axis.majorTick;
_4.forEach(_1e.major,function(_21){
if(!_1c&&_21.value==(this._vAxis.opt.leftBottom?_1d.bounds.from:_1d.bounds.to)){
return;
}
var y=dim.height-_1a.b-vt(_21.value);
var _22=this.createLine(s,{x1:_1a.l,y1:y,x2:dim.width-_1a.r,y2:y}).setStroke(_1b);
if(this.animate){
this._animateGrid(_22,"h",_1a.l,_1a.r+_1a.l-dim.width);
}
},this);
}
}
}
}
if(this._hAxis){
var _23=this._hAxis.getScaler();
if(_23){
var ht=_23.scaler.getTransformerFromModel(_23);
_1e=this._hAxis.getTicks();
if(this!=null){
if(_1e&&this.opt.vMinorLines){
_1b=this.opt.minorVLine||(ta.grid&&ta.grid.minorLine)||ta.axis.minorTick;
_4.forEach(_1e.minor,function(_24){
if(!_1c&&_24.value==(this._hAxis.opt.leftBottom?_23.bounds.from:_23.bounds.to)){
return;
}
var x=_1a.l+ht(_24.value);
var _25=this.createLine(s,{x1:x,y1:_1a.t,x2:x,y2:dim.height-_1a.b}).setStroke(_1b);
if(this.animate){
this._animateGrid(_25,"v",dim.height-_1a.b,dim.height-_1a.b-_1a.t);
}
},this);
}
if(_1e&&this.opt.vMajorLines){
_1b=this.opt.majorVLine||(ta.grid&&ta.grid.majorLine)||ta.axis.majorTick;
_4.forEach(_1e.major,function(_26){
if(!_1c&&_26.value==(this._hAxis.opt.leftBottom?_23.bounds.from:_23.bounds.to)){
return;
}
var x=_1a.l+ht(_26.value);
var _27=this.createLine(s,{x1:x,y1:_1a.t,x2:x,y2:dim.height-_1a.b}).setStroke(_1b);
if(this.animate){
this._animateGrid(_27,"v",dim.height-_1a.b,dim.height-_1a.b-_1a.t);
}
},this);
}
}
}
}
this.dirty=false;
return this;
},_animateGrid:function(_28,_29,_2a,_2b){
var _2c=_29=="h"?[_2a,0]:[0,_2a];
var _2d=_29=="h"?[1/_2b,1]:[1,1/_2b];
fx.animateTransform(_1.delegate({shape:_28,duration:1200,transform:[{name:"translate",start:_2c,end:[0,0]},{name:"scale",start:_2d,end:[1,1]},{name:"original"}]},this.animate)).play();
}});
});
